//===================================================================
// pas2000s.h
//-------------------------------------------------------------------
//
// PA-S2000 Sample
//
//-------------------------------------------------------------------
// CH1CALM͂AgKʒȗÕf[^\܂B
//===================================================================

#pragma once

#include <windows.h>
#include "Pas2000w.h"

namespace SamplePas2000 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Security::Permissions;

	/// <summary>
	/// Form1 ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

		//-------------------------------------------------------------------
		// bZ[W̏
		//-------------------------------------------------------------------
		[SecurityPermission(SecurityAction::Demand, Flags=SecurityPermissionFlag::UnmanagedCode)]
		virtual void WndProc(Message% m) override
		{
			if (m.Msg == WM_PAS2000_DATA_READY)
				DataReady( m.WParam, m.LParam );
			else if (m.Msg == WM_PAS2000_ERROR)
				DataThreadError( m.WParam, m.LParam );
			Form::WndProc(m);
		}

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

		static Pas2000^				Pas2000w;
		static Pas2000::TSETMODE^	mSetMode;
		static short				mwDeviceNo;

		static const int WM_PAS2000_BASE		= WM_USER + 100;
		static const int WM_PAS2000_DATA_READY	= WM_PAS2000_BASE + Pas2000::WM_DATA_READY;
		static const int WM_PAS2000_ERROR		= WM_PAS2000_BASE + Pas2000::WM_DATA_THREAD_ERROR;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->SuspendLayout();
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(276, 247);
			this->Name = L"Form1";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"PA-S2000 Sample";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->FormClosed += gcnew System::Windows::Forms::FormClosedEventHandler(this, &Form1::Form1_FormClosed);
			this->ResumeLayout(false);

		}
#pragma endregion
			//-------------------------------------------------------------------
		    // 
		    //-------------------------------------------------------------------
	private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
				 int i;
                 int dwDrvVer, dwDllVer, dwMemSize, hwnd;
                 short wDeviceNo;
				 String^ szbuf;
                 Pas2000::TDEVINFO^ DevInfo;

                 //------------------------------------------------------------
                 // 
                 //------------------------------------------------------------
				 Pas2000w = gcnew Pas2000();
				 mSetMode = gcnew Pas2000::TSETMODE();
				 mSetMode->dwVoltDiv	  = gcnew array<int>(Pas2000::NUM_CH);
				 mSetMode->dwVoltPos	  = gcnew array<int>(Pas2000::NUM_CH);
				 mSetMode->dwVertCoupling = gcnew array<int>(Pas2000::NUM_CH);
				 mSetMode->dwBandWidth	  = gcnew array<int>(Pas2000::NUM_CH);
				 DevInfo  = gcnew Pas2000::TDEVINFO();
				 DevInfo->VendorID		  = gcnew array<char>(Pas2000::VID_LENGTH);
				 DevInfo->ProductID		  = gcnew array<char>(Pas2000::PID_LENGTH);
				 for ( i = 0 ; i < Pas2000::VID_LENGTH; i++ )
					 DevInfo->VendorID[ i ]  = 0;
				 for ( i = 0 ; i < Pas2000::PID_LENGTH; i++ )
					 DevInfo->ProductID[ i ] = 0;
				 DevInfo->FirmVer = 0;
				 DevInfo->FpgaVer = 0;
                 //------------------------------------------------------------
                 // foCX̎gp錾
                 //------------------------------------------------------------
                 wDeviceNo = Pas2000::DEVICE_AUTO;
                 hwnd = this->Handle.ToInt32();			// EChEnh
                 if ( false == Pas2000w->Create( &wDeviceNo, hwnd, WM_PAS2000_BASE ) ) {
                     ErrorMessage( Pas2000::DEVICE_AUTO );
                     return;
                 }
				 szbuf = String::Format("foCX {0} ̎gp錾܂B", wDeviceNo );
                 ResultMessage( szbuf );
                 mwDeviceNo = wDeviceNo;
                 //------------------------------------------------------------
                 // o[W擾
                 //------------------------------------------------------------
                 if ( false == Pas2000w->GetVersion( &dwDrvVer, &dwDllVer ) ) {
                     ErrorMessage( Pas2000::DEVICE_AUTO );
                     return;
                 }
                 szbuf = String::Concat("o[W\n",
										String::Format("   DRV Version : 0x{0:x8}\n", dwDrvVer),
										String::Format("   DLL Version : 0x{0:x8}",   dwDllVer));
                 ResultMessage( szbuf );
                 //------------------------------------------------------------
                 // foCX擾
                 //------------------------------------------------------------
				 Pas2000::TDEVINFO% di = *DevInfo;
                 if ( false == Pas2000w->GetDevInfo( mwDeviceNo, di ) ) {
                     ErrorMessage( mwDeviceNo );
                     return;
                 }
                 szbuf = String::Concat("foCX\n",
										String::Format("   Firm Version : {0:f2}\n", 
															DevInfo->FirmVer / 100.0), 
										String::Format("   FPGA Version : {0:f2}",
															DevInfo->FpgaVer / 100.0));
                 ResultMessage( szbuf );
                 //------------------------------------------------------------
                 // TCY擾
                 //------------------------------------------------------------
                 if ( false == Pas2000w->GetMemSize( mwDeviceNo, &dwMemSize ) ) {
                     ErrorMessage( mwDeviceNo );
                     return;
                 }
                 szbuf = String::Copy( "TCY\n" );
                 if ( 0 == dwMemSize ) {
                     szbuf = String::Concat( szbuf, "   128K|Cg" );
				 }
				 else {
                     szbuf = String::Concat( szbuf, "   1M|Cg" );
                 }
                 ResultMessage( szbuf );
                 //------------------------------------------------------------
                 // TvO샂[h()ݒ
                 //------------------------------------------------------------
                 mSetMode->dwVoltDiv[ Pas2000::CH1 ]      = Pas2000::VOLTDIV_1;		// XP[
                 mSetMode->dwVoltDiv[ Pas2000::CH2 ]      = Pas2000::VOLTDIV_1;
                 mSetMode->dwVoltPos[ Pas2000::CH1 ]      = 100;					// |WV
                 mSetMode->dwVoltPos[ Pas2000::CH2 ]      = 100;
                 mSetMode->dwVertCoupling[ Pas2000::CH1 ] = Pas2000::CUP_DC;		// ͌
                 mSetMode->dwVertCoupling[ Pas2000::CH2 ] = Pas2000::CUP_DC;
                 //------------------------------------------------------------
                 // TvO샂[h()ݒ
                 //------------------------------------------------------------
                 mSetMode->dwMemSize					  = Pas2000::MEMSIZE_10K;	// TCY
                 mSetMode->dwSamplingTime				  = Pas2000::TIMEDIV_200NS;	// XP[
                 mSetMode->dwBandWidth[ Pas2000::CH1 ]	  = Pas2000::BW_FULL;		// gш
                 mSetMode->dwBandWidth[ Pas2000::CH2 ]	  = Pas2000::BW_FULL;
                 mSetMode->dwSamplingMode				  = Pas2000::SMP_REAL;		// TvO[h
                 mSetMode->dwAcqMode					  = Pas2000::ACQ_SINGLE;	// ANCWV[h
                 //------------------------------------------------------------
                 // TvO샂[h(gK)ݒ
                 //------------------------------------------------------------
                 mSetMode->dwTrigMode		= Pas2000::TMODE_AUTO;				// gK[h
                 mSetMode->dwTrigSource		= Pas2000::TSRC_CH1;				// gK\[X
                 mSetMode->dwTrigCoupling	= Pas2000::TCUP_DC;					// gK͌
                 mSetMode->dwTrigSlope		= Pas2000::TSLP_POS;				// gKX[v
                 mSetMode->dwTrigLevel		= 250;								// gKx
                 mSetMode->dwTrigPos		= 5000;								// gK|WV
                 mSetMode->dwTrigDelay		= 0;								// gKfBC
                 mSetMode->dwTrigPulse		= Pas2000::PULSE_NONE;				// pXgK(pX)
                 mSetMode->dwTrigPulseWidth	= 0;								// pXgK(pX)
				 Pas2000::TSETMODE% sm = *mSetMode;
                 if ( false == Pas2000w->SetMode( mwDeviceNo, sm ) ) {
                     ErrorMessage( mwDeviceNo );
                     return;
                 }
                 szbuf = String::Concat("TvO샂[hݒ\n",
										" yݒz\n",
										String::Format("   CH1 XP[ : {0}\n", 
															mSetMode->dwVoltDiv[ Pas2000::CH1 ]),
                                        String::Format("   CH2 XP[ : {0}\n", 
															mSetMode->dwVoltDiv[ Pas2000::CH2 ]),
                                        String::Format("   CH1 |WV : {0}\n", 
															mSetMode->dwVoltPos[ Pas2000::CH1 ]),
                                        String::Format("   CH2 |WV : {0}\n",	
															mSetMode->dwVoltPos[ Pas2000::CH2 ]),
                                        String::Format("   CH1 ͌ : {0}\n", 
															mSetMode->dwVertCoupling[ Pas2000::CH1 ]),
                                        String::Format("   CH2 ͌ : {0}\n", 
															mSetMode->dwVertCoupling[ Pas2000::CH2 ]),
                                        " yݒz\n",
                                        String::Format("   TCY : {0}\n", 
															mSetMode->dwMemSize),
                                        String::Format("   TvO^C : {0}\n", 
															mSetMode->dwSamplingTime),
                                        String::Format("   CH1 gш : {0}\n",	
															mSetMode->dwBandWidth[ Pas2000::CH1 ]),
                                        String::Format("   CH2 gш : {0}\n",	
															mSetMode->dwBandWidth[ Pas2000::CH2 ]),
                                        String::Format("   TvO[h : {0}\n",	
															mSetMode->dwSamplingMode),
                                        String::Format("   ANCWV[h : {0}\n", 
															mSetMode->dwAcqMode),
                                        " ygKݒz\n",
                                        String::Format("   [h : {0}\n", 
															mSetMode->dwTrigMode),
                                        String::Format("   \[X : {0}\n", 
															mSetMode->dwTrigSource),
                                        String::Format("   ͌ : {0}\n", 
															mSetMode->dwTrigCoupling),
                                        String::Format("   X[v : {0}\n", 
															mSetMode->dwTrigSlope),
                                        String::Format("   x : {0}\n",	
															mSetMode->dwTrigLevel),
                                        String::Format("   |WV : {0}\n", 
															mSetMode->dwTrigPos),
                                        String::Format("   fBC : {0}\n", 
															mSetMode->dwTrigDelay),
                                        String::Format("   pX : {0}\n", 
															mSetMode->dwTrigPulse),
                                        String::Format("   pX : {0}\n", 
															mSetMode->dwTrigPulseWidth) );
                 ResultMessage( szbuf );
                 //------------------------------------------------------------
                 // TvOJn
                 //------------------------------------------------------------
                 ResultMessage( "TvOJn܂B" );
                 if ( false == Pas2000w->StartSampling( mwDeviceNo, 0 ) ) {
                     ErrorMessage( mwDeviceNo );
                     return;
                 }
			 }

             //-------------------------------------------------------------------
             // I
             //-------------------------------------------------------------------
	private: System::Void Form1_FormClosed(System::Object^  sender, System::Windows::Forms::FormClosedEventArgs^  e) {
				 // foCX̎gpJ
                 if ( false == Pas2000w->Close( mwDeviceNo ) )
                     ErrorMessage( mwDeviceNo );
                 ResultMessage( "foCXJ܂B" );
			 }

             //-------------------------------------------------------------------
             // `f[^
             //-------------------------------------------------------------------
	private: void DataReady( IntPtr wParam, IntPtr lParam ) {
                 String^ szbuf;
                 String^ sztmp;
                 short wDevNo;
                 double dblData;
                 int i, dwData, dwStatus, dwNumData, dwInitArg;

                 if ( Pas2000::DEVICE_ID != lParam.ToInt32() )
                     return;
                 wDevNo = (short)wParam.ToInt32();
                 //------------------------------------------------------
                 // TvO~
                 //------------------------------------------------------
                 if ( false == Pas2000w->StopSampling( wDevNo ) ) {
                     ErrorMessage( wDevNo );
                  }
                 ResultMessage( "TvO~܂B" );
                 //------------------------------------------------------
                 // TvOXe[^X擾
                 //------------------------------------------------------
                 if ( false == Pas2000w->GetStatus( wDevNo, &dwStatus, &dwNumData, &dwInitArg ) ) {
                     ErrorMessage( wDevNo );
                     return;
                 }
                 szbuf = String::Concat("TvOXe[^X擾\n", 
										String::Format("   TvOXe[^X : 0x{0:x}\n", dwStatus),
										String::Format("   ǃTvOf[^ : {0}", dwNumData) );
                 ResultMessage( szbuf );
                 //------------------------------------------------------
                 // TvOf[^擾
                 //------------------------------------------------------
                 if ( dwNumData == 0 )
                     return;
				 array<int> ^ dwAdData = gcnew array <int>(dwNumData);
				 pin_ptr<int> pdwAdData = &dwAdData[0];
				 if ( false == Pas2000w->GetData( wDevNo, dwNumData, pdwAdData ) ) {
                     ErrorMessage( wDevNo );
                     return;
                 }
                 szbuf = String::Concat("TvOf[^ ", dwNumData.ToString(), 
											" 擾܂B\n\n",
                                            "CH1 擾f[^\n" );
                 for ( i = 4990; i <= 5010; i++ ) {		// 擾f[^\
                     dwData = pdwAdData[ i ] & Pas2000::ADDATA_MASK_BIT;			// CH1
                     //dwData = (pdwAdData[ i ] >> 16) & Pas2000::ADDATA_MASK_BIT;	// CH2
                     dblData = VoltValue( dwData );
					 sztmp = String::Format("   {0} : {1} ({2})\n",
												i.ToString(), dwData.ToString(), dblData.ToString("f2"));
                     szbuf = String::Concat( szbuf, sztmp );
                 }
                 szbuf = String::Concat(szbuf,
										"\n gKʒu : ", 
                                        mSetMode->dwTrigPos.ToString(), 
                                        " ̑O10\\n",
                                        "@@JbR͓dl(PmV)" );
                 ResultMessage( szbuf );
                 //----------------------------------------------------------
                 // I
                 //----------------------------------------------------------
                 this->Close();
             }

             //-------------------------------------------------------------------
             // dlZ
             //-------------------------------------------------------------------
	private: double VoltValue( int addata ) {
                 int voltdiv;
                 double vfull;

                 // Volt/div
                 switch ( mSetMode->dwVoltDiv[ Pas2000::CH1 ] ) {
                     case Pas2000::VOLTDIV_0:
                         voltdiv = 10;
                         break;
                     case Pas2000::VOLTDIV_1:
                         voltdiv = 20;
                         break;
                     case Pas2000::VOLTDIV_2:
                         voltdiv = 50;
                         break;
                     case Pas2000::VOLTDIV_3:
                         voltdiv = 100;
                         break;
                     case Pas2000::VOLTDIV_4:
                         voltdiv = 200;
                         break;
                     case Pas2000::VOLTDIV_5:
                         voltdiv = 500;
                         break;
                     case Pas2000::VOLTDIV_6:
                         voltdiv = 1000;
                         break;
                     case Pas2000::VOLTDIV_7:
                         voltdiv = 2000;
                         break;
                     default: voltdiv = 0;
                 }
                 // tXP[d(v[u10:1)
                 vfull = voltdiv * Pas2000::PROBE_X10 * 10;
                 // dlɊZ
                 return ( ( vfull * addata / Pas2000::RES_VERT )
								- ( vfull * mSetMode->dwVoltPos[ Pas2000::CH1 ] / Pas2000::RES_VOLTPOS ) );
             }

             //-------------------------------------------------------------------
             // `f[^擾pXbhG[
             //-------------------------------------------------------------------
	private: void DataThreadError( IntPtr wParam, IntPtr lParam ) {

				 if ( Pas2000::DEVICE_ID == lParam.ToInt32() ) {
                     ErrorMessage( (short)wParam.ToInt32() );
                 }
			 }

             //-------------------------------------------------------------------
             // ʂ\
             //-------------------------------------------------------------------
	private: void ResultMessage(String^ pstrbuf) {

                 MessageBox::Show(pstrbuf, this->Text,
									MessageBoxButtons::OK, MessageBoxIcon::Information);

			 }

             //-------------------------------------------------------------------
             // G[bZ[W\
             //-------------------------------------------------------------------
	private: void ErrorMessage(short devno) {
                 int dwRes = Pas2000w->GetLastErr( devno );
                 String^ strbuf;

                 strbuf = String::Concat("PA-S2000 error\n\n",
											String::Format("Error code: 0x{0:x8}", dwRes));
                 MessageBox::Show(strbuf, this->Text,
									MessageBoxButtons::OK, MessageBoxIcon::Stop);
             }

	};
}

