//===================================================================
// pas2000w.cs
//-------------------------------------------------------------------
//
// PA-S2000 Wrapper
//
//===================================================================
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace SamplePas2000
{
    class Pas2000
    {
		//-----------------------------------------------------------------
		// foCXANZXɊւ`
		//-----------------------------------------------------------------
		public const int	MAX_DEVICE				= 16;			// őfoCX
		public const short	DEVICE_AUTO				= -1;			// foCXw
		//-----------------------------------------------------------------
		// `lɊւ`
		//-----------------------------------------------------------------
		public const int	NUM_CH					= 2;			// Ή`l
		public const int	CH1						= 0;			// CH1
		public const int	CH2						= 1;			// CH2
		//-----------------------------------------------------------------
		// foCXɊւ`
		//-----------------------------------------------------------------
		public const int	VID_LENGTH				= 8;			// x_ʕ
		public const int	PID_LENGTH				= 16;			// v_Ngʕ
		//-----------------------------------------------------------------
		// TvOXe[^X̒`
		//-----------------------------------------------------------------
		public const int	STS_STOP				= 0x0;			// CxgȂ(~)
		public const int	STS_PRE_TRIG			= 0x1;			// gK҂ɂȂȌ
		public const int	STS_WAIT_FOR_TRIG		= 0x3;			// gK҂̏
		public const int	STS_TRIG_DETECT			= 0x7;			// gK|
		public const int	STS_AUTO_RUN			= 0xB;			// ^CAEgt[ōăX^[g
		//-----------------------------------------------------------------
		// G[R[h̒`
		//-----------------------------------------------------------------
		public const int	SUCCESS					= 0;			// ُȂ
		public const int	ERR_SYSTEM				= 1;			// VXeG[
		public const int	ERR_NO_DEVICE			= 2;			// gp\ȃfoCX܂
		public const int	ERR_IN_USE				= 3;			// w̃foCX͎gpł
		public const int	ERR_INVALID_DEVICENO	= 4;			// sȃfoCXʔԍł
		public const int	ERR_INVALID_ARGUMENT	= 5;			// sȈw肳܂
		public const int	ERR_INTERNAL			= 6;			// G[ł
		public const int	ERR_TRANSFER_TIMEOUT	= 7;			// f[^]^CAEgɂȂ܂
		public const int	ERR_TRANSFER_CANCEL		= 8;			// f[^]LZ܂
		public const int	ERR_TRANSFER_FAIL		= 9;			// f[^]s܂
		public const int	ERR_BUFF_OVERFLOW		= 10;			// obt@I[o[t[ł
		public const int	ERR_MEMSIZE				= 11;			// 擾TCYُł
		public const int	ERR_DEVICE				= 12;			// foCXG[ł
		//-----------------------------------------------------------------
		// bZ[W̒`
		//-----------------------------------------------------------------
		public const int	WM_DATA_READY			= 1;			// `f[^
		public const int	WM_DATA_THREAD_ERROR	= 2;			// f[^擾pXbhG[
		//-----------------------------------------------------------------
		// ̑̒`
		//-----------------------------------------------------------------
		public const int	DEVICE_ID				= 0x5320;		// foCXID
		public const int	RES_VERT				= 1024;			// \(1024|Cg)
		public const int	RES_VOLTPOS				= 500;			// d|WV\
		public const int	ADBUFF_MAX_SIZE			= 1000000;		// ݍőf[^
		public const int	ADDATA_MASK_BIT			= 0x3FF;		// rbg}XN
		//-----------------------------------------------------------------
		// eݒl̒`
		//-----------------------------------------------------------------
		// (d)XP[
		public const int	VOLTDIV_0				= 0;			// 10mV  or 100mV
		public const int	VOLTDIV_1				= 1;			// 20mV  or 200mV
		public const int	VOLTDIV_2				= 2;			// 50mV  or 500mV
		public const int	VOLTDIV_3				= 3;			// 100mV or 1V
		public const int	VOLTDIV_4				= 4;			// 200mV or 2V
		public const int	VOLTDIV_5				= 5;			// 500mV or 5V
		public const int	VOLTDIV_6				= 6;			// 1V    or 10V
		public const int	VOLTDIV_7				= 7;			// 2V    or 20V
		// v[u
		public const int	PROBE_X1				= 1;			// 1:1
		public const int	PROBE_X10				= 10;			// 10:1
        public const int    PROBE_X100              = 100;			// 100:1
		// ͌
		public const int	CUP_DC					= 0;			// DC
		public const int	CUP_AC					= 1;			// AC
		// TCY
		public const int	MEMSIZE_10K				= 0;			// 10kPoint
		public const int	MEMSIZE_100K			= 1;			// 100kPoint
		public const int	MEMSIZE_1M				= 2;			// 1MPoint
		// ()XP[
		public const int	TIMEDIV_10NS			= 10;			// 10ns
		public const int	TIMEDIV_20NS			= 20;			// 20ns
		public const int	TIMEDIV_50NS			= 50;			// 50ns
		public const int	TIMEDIV_100NS			= 100;			// 100ns
		public const int	TIMEDIV_200NS			= 200;			// 200ns
		public const int	TIMEDIV_500NS			= 500;			// 500ns
		public const int	TIMEDIV_1US				= 1000;			// 1us
		public const int	TIMEDIV_2US				= 2000;			// 2us
		public const int	TIMEDIV_5US				= 5000;			// 5us
		public const int	TIMEDIV_10US			= 10000;		// 10us
		public const int	TIMEDIV_20US			= 20000;		// 20us
		public const int	TIMEDIV_50US			= 50000;		// 50us
		public const int	TIMEDIV_100US			= 100000;		// 100us
		public const int	TIMEDIV_200US			= 200000;		// 200us
		public const int	TIMEDIV_500US			= 500000;		// 500us
		public const int	TIMEDIV_1MS				= 1000000;		// 1ms
		public const int	TIMEDIV_2MS				= 2000000;		// 2ms
		public const int	TIMEDIV_5MS				= 5000000;		// 5ms
		public const int	TIMEDIV_10MS			= 10000000;		// 10ms
		// gш
		public const int	BW_FULL					= 0;			// FULL
		public const int	BW_20MHZ				= 1;			// 20MHz
		// TvO[h
		public const int	SMP_REAL				= 0;			// ATvO
		public const int	SMP_EQU					= 1;			// TvO
		// ANCWV[h
		public const int	ACQ_SINGLE				= 0;			// VOVbg
		public const int	ACQ_ROLL				= 1;			// [
		// gK[h
		public const int	TMODE_AUTO				= 0;			// I[g
		public const int	TMODE_NORMAL			= 1;			// m[}
		public const int	TMODE_FREERUN			= 2;			// t[
		// gK\[X
		public const int	TSRC_CH1				= 0;			// CH1
		public const int	TSRC_CH2				= 1;			// CH2
		public const int	TSRC_EXT				= 2;			// O
		// gK͌
		public const int	TCUP_DC					= 0;			// DC
		public const int	TCUP_LF					= 1;			// LFrej
		public const int	TCUP_HF					= 2;			// HFrej
		// gKX[v
		public const int	TSLP_POS				= 0;			// (オ)
		public const int	TSLP_NEG				= 1;			// ()
		// pXgK(pX)
		public const int	PULSE_NONE				= 0;			// gp
		public const int	PULSE_UNDER				= 1;			// pX
		public const int	PULSE_ABOVE				= 2;			// pXȏ

		//-----------------------------------------------------------------
		// foCX\
		//-----------------------------------------------------------------
		[StructLayout(LayoutKind.Sequential)]
		public struct TDEVINFO
		{
			// x_ʕ
			[MarshalAs(UnmanagedType.ByValArray, SizeConst=Pas2000.VID_LENGTH)]
			public byte[]	VendorID;
			// v_Ngʕ
			[MarshalAs(UnmanagedType.ByValArray, SizeConst=Pas2000.PID_LENGTH)]
			public byte[]	ProductID;
			// t@[EFÃo[W
			public byte		FirmVer;
			// FPGÃo[W
			public byte		FpgaVer;
		};
		//-----------------------------------------------------------------
		// TvOp[^\
		//-----------------------------------------------------------------
		[StructLayout(LayoutKind.Sequential)]
		public struct TSETMODE
		{
			// ݒ
			[MarshalAs(UnmanagedType.ByValArray, SizeConst=Pas2000.NUM_CH)]
			public int[]	dwVoltDiv;			// (d)XP[
			[MarshalAs(UnmanagedType.ByValArray, SizeConst=Pas2000.NUM_CH)]
			public int[]	dwVoltPos;			// (d)|WV
			[MarshalAs(UnmanagedType.ByValArray, SizeConst=Pas2000.NUM_CH)]
			public int[]	dwVertCoupling;		// (d)͌

			// ݒ
			public int		dwMemSize;			// TCY
			public int		dwSamplingTime;		// ()XP[
			[MarshalAs(UnmanagedType.ByValArray, SizeConst=Pas2000.NUM_CH)]
			public int[]	dwBandWidth;		// gш
			public int		dwSamplingMode;		// TvO[h
			public int		dwAcqMode;			// ANCWV[h

			// gKݒ
			public int		dwTrigMode;			// gK[h
			public int		dwTrigSource;		// gK\[X
			public int		dwTrigCoupling;     // gK͌
			public int		dwTrigSlope;		// gKX[v
			public int		dwTrigLevel;		// gKx
			public int		dwTrigPos;			// gK|WV
			public int		dwTrigDelay;        // gKfBC
			public int		dwTrigPulse;		// pXgK(pX)
			public int		dwTrigPulseWidth;	// pXgK(pX)
		};

		//-------------------------------------------------------------------
		// API
		//-------------------------------------------------------------------
		// o[W擾
		[DllImport("pas2000.dll")]
        public static extern bool Pas2000GetVersion(ref int pdwDrvVer, ref int pdwDllVer);

		// foCX̌
		[DllImport("pas2000.dll")]
		public static extern bool Pas2000Create(ref short pwDeviceNo, int hWnd, short uWMBase);

		// foCX̊J
		[DllImport("pas2000.dll")]
		public static extern bool Pas2000Close(int wDeviceNo);

		// foCX擾
		[DllImport("pas2000.dll")]
		public static extern bool Pas2000GetDevInfo(short wDeviceNo, ref TDEVINFO pDevInfo);

		// TCY擾
		[DllImport("pas2000.dll")]
		public static extern bool Pas2000GetMemSize(short wDeviceNo, ref int pdwMemSize);

		// TvO샂[h̐ݒ
		[DllImport("pas2000.dll")]
		public static extern bool Pas2000SetMode(short wDeviceNo, ref TSETMODE pSetMode);

		// TvOJn
		[DllImport("pas2000.dll")]
		public static extern bool Pas2000StartSampling(short wDeviceNo, int dwInitArg);

		// TvO~
		[DllImport("pas2000.dll")]
		public static extern bool Pas2000StopSampling(short wDeviceNo);

		// TvOXe[^X擾
		[DllImport("pas2000.dll")]
		public static extern bool Pas2000GetStatus(short wDeviceNo, ref int pdwStatus,
															ref int pdwNumData, ref int pvInitArg);

		// TvOf[^擾
		[DllImport("pas2000.dll")]
        public static extern bool Pas2000GetData(short wDeviceNo, int dwNumData, int[] pData);

		// G[R[h
		[DllImport("pas2000.dll")]
		public static extern int Pas2000GetLastError(short wDeviceNo);

		//-------------------------------------------------------------------
		// 		o[W擾
		// 		pdwDrvVer	hCõo[Wi[̈ւ̃|C^
		//			pdwDllVer	DLL̃o[Wi[̈ւ̃|C^
		// ߂l	 True
		//			s False
		//-------------------------------------------------------------------
        public bool GetVersion(ref int pdwDrvVer, ref int pdwDllVer)
        {
			return Pas2000GetVersion(ref pdwDrvVer, ref pdwDllVer);
		}
		//-------------------------------------------------------------------
		// 		foCX̌
		// 		pwDeviceNo	gpfoCX̃foCXʔԍi[̈ւ
		//						|C^
		//			hWnd		DLLo郁bZ[W󂯎EBhẼnh
		//			uWMBase		o郁bZ[WID̃x[Xl
		// ߂l	 True
		//			s False
		//-------------------------------------------------------------------
		public bool Create(ref short pwDeviceNo, int hWnd, short uWMBase)
		{
			return Pas2000Create(ref pwDeviceNo, hWnd, uWMBase);
		}
		//-------------------------------------------------------------------
		// 		foCX̊J
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		// ߂l	 True
		//			s False
		//-------------------------------------------------------------------
		public bool Close(short wDeviceNo)
		{
			return Pas2000Close(wDeviceNo);
		}
		//-------------------------------------------------------------------
		// 		foCX̎擾
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			pDevInfo	foCXi[\̂ւ̃|C^
		// ߂l	 True
		//			s False
		//-------------------------------------------------------------------
		public bool GetDevInfo(short wDeviceNo, ref TDEVINFO pDevInfo)
		{
			return Pas2000GetDevInfo(wDeviceNo, ref pDevInfo);
		}
		//-------------------------------------------------------------------
		// 		TCY̎擾
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			pdwMemSize	Ă郁TCYi[̈ւ̃|C^
		// ߂l	 True
		//			s False
		//-------------------------------------------------------------------
		public bool GetMemSize(short wDeviceNo, ref int pdwMemSize)
		{
			return Pas2000GetMemSize(wDeviceNo, ref pdwMemSize);
		}
		//-------------------------------------------------------------------
		// 		TvO샂[h̐ݒ
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			pSetMode	TvOp[^̃|C^
		// ߂l	 True
		//			s False
		//-------------------------------------------------------------------
		public bool SetMode(short wDeviceNo, ref TSETMODE pSetMode)
		{
			return Pas2000SetMode(wDeviceNo, ref pSetMode);
		}
		//-------------------------------------------------------------------
		// 		TvO̊Jn
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			dwInitArg	\(0w)
		// ߂l	 True
		//			s False
		//-------------------------------------------------------------------
		public bool StartSampling(short wDeviceNo, int dwInitArg)
		{
			return Pas2000StartSampling(wDeviceNo, 0);
		}
		//-------------------------------------------------------------------
		// 		TvO̒~
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		// ߂l	 True
		//			s False
		//-------------------------------------------------------------------
		public bool StopSampling(short wDeviceNo)
		{
			return Pas2000StopSampling(wDeviceNo);
		}
		//-------------------------------------------------------------------
		// 		TvOXe[^X擾
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			pdwStatus	TvOXe[^X
		//			pdwNumData	ǃTvOf[^
		//			pvInitArg	\
		// ߂l	 True
		//			s False
		//-------------------------------------------------------------------
		public bool GetStatus(short wDeviceNo, ref int pdwStatus, 
										ref int pdwNumData, ref int pvInitArg)
		{
			return Pas2000GetStatus(wDeviceNo, ref pdwStatus, ref pdwNumData, ref pvInitArg);
		}
		//-------------------------------------------------------------------
		// 		TvOf[^擾
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			dwNumData	擾f[^
		//			pdwData		擾f[^i[̈ւ̃|C^
		// ߂l	 True
		//			s False
		//-------------------------------------------------------------------
        public bool GetData(short wDeviceNo, int dwNumData, int[] pData)
        {
            return Pas2000GetData(wDeviceNo, dwNumData, pData);
        }

        //-------------------------------------------------------------------
		// 		G[R[h̎擾
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		// ߂l	G[R[h
		//-------------------------------------------------------------------
		public int GetLastError(short wDeviceNo)
		{
			return Pas2000GetLastError(wDeviceNo);
		}
	
    }
}
